%define desktop_file 1
%if %{desktop_file}
%define desktop_file_utils_version 0.2.93
%endif
Summary: An X Window System based IBM 3278/3279 terminal emulator.
Name: x3270
Version: 3.3.2.p1
Release: 7
License: MIT
Group: Applications/Internet
URL: http://www.geocities.com/SiliconValley/Peaks/7814
Source0: http://x3270.bgp.nu/download/x3270-332p1.tgz
Source1: http://x3270.bgp.nu/download/c3270-332p2.tgz
Patch0: x3270-3.2.16-redhat.patch
Patch1: x3270-3.2.20-timeh.patch
Patch2: x3270-3.2-segfault.patch
Patch3: c3270-332-ncursesw.patch
Patch4: x3270-3.3-syntax.patch
Prereq:  %{_prefix}/X11R6/bin/mkfontdir
BuildPreReq: ncurses-devel readline-devel glibc-devel
BuildRoot: %{_tmppath}/%{name}-root
%if %{desktop_file}
Requires: /usr/bin/desktop-file-install
BuildPrereq: desktop-file-utils >= %{desktop_file_utils_version}
%endif
Obsoletes: x3270-tcl

%package x11
Summary: IBM 3278/3279 terminal emulator for the X Window System.
Group: Applications/Internet
BuildRequires: xorg-x11-devel
Requires: %{name} = %{version}

%package text
Summary: IBM 3278/3279 terminal emulator for text mode.
Group: Applications/Internet
Requires: %{name} = %{version}

%description
The x3270 package contains files needed for emulating the IBM 3278/3279
terminals, commonly used with mainframe applications.

You will also need to install a frontend for %{name}. Available frontends
are %{name}-x11 (for the X Window System), %{name}-text (for text mode) and
%{name}-tcl (for Tcl scripting).

%description x11
The x3270 program opens a window in the X Window System which emulates
the actual look of an IBM 3278/3279 terminal, commonly used with
mainframe applications.  x3270 also allows you to telnet to an IBM
host from the x3270 window.

Install the %{name}-x11 package if you need to access IBM hosts using an IBM
3278/3279 terminal emulator from X11.

%description text
The c3270 program opens a 3270 terminal which emulates the actual look of an
IBM 3278/3279 terminal, commonly used with mainframe applications.
x3270 also allows you to telnet to an IBM host from the x3270 window.

Install the %{name}-text package if you need to access IBM hosts using an IBM
3278/3279 terminal emulator without running X.

%prep
%setup -q -n x3270-3.3 -a 1
%patch0 -p1 -b .rh
%patch1 -p1 -b .timeh
%patch2 -p1 -b .seg1
%patch3 -p1 -b .ncursesw
%patch4 -p1 -b .syntax

%build
export PATH=$PATH:/usr/X11R6/bin
export CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS"
# Set LIBX3270DIR to something we can share with x3270-text
perl -pi -e "s,LIBX3270DIR =.*,LIBX3270DIR = /usr/lib/x3270,g" Imakefile.in
libtoolize --copy --force
%configure --enable-app-defaults --prefix=/usr/X11R6
xmkmf -a
make
cd c3270-3.3
autoconf
libtoolize --copy --force
%configure --prefix=/usr
make

%install
export PATH=$PATH:/usr/X11R6/bin
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_prefix}/bin
mkdir -p $RPM_BUILD_ROOT%{_prefix}/lib/x3270
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1
mkdir -p ${RPM_BUILD_ROOT}%{_prefix}/X11R6/bin
mkdir -p ${RPM_BUILD_ROOT}%{_prefix}/X11R6/man/man1
mkdir -p ${RPM_BUILD_ROOT}%{_prefix}/X11R6/lib/X11/fonts/misc
mkdir -p ${RPM_BUILD_ROOT}%{_prefix}/X11R6/lib/X11/app-defaults

# XXX Hack around mkfontdir madness on install.
install -m755 x3270 $RPM_BUILD_ROOT%{_prefix}/X11R6/bin
install -m755 x3270if $RPM_BUILD_ROOT%{_prefix}/X11R6/bin
install -m644 *pcf.gz $RPM_BUILD_ROOT%{_prefix}/X11R6/lib/X11/fonts/misc
install -m644 X3270.ad $RPM_BUILD_ROOT%{_prefix}/X11R6/lib/X11/app-defaults/X3270
install -m644 ibm_hosts $RPM_BUILD_ROOT%{_prefix}/lib/x3270
for i in x3270 x3270if x3270-script ibm_hosts; do
	install -m644 $i.man $RPM_BUILD_ROOT%{_prefix}/X11R6/man/man1/$i.1x
done
install -m755 pr3287/pr3287 $RPM_BUILD_ROOT%{_prefix}/X11R6/bin
install -m644 pr3287/pr3287.man $RPM_BUILD_ROOT%{_prefix}/X11R6/man/man1/pr3287.1x
cd c3270-3.3
install -m755 c3270 $RPM_BUILD_ROOT%{_prefix}/bin
install -m755 x3270if $RPM_BUILD_ROOT%{_prefix}/bin
install -m755 pr3287/pr3287 $RPM_BUILD_ROOT%{_prefix}/bin
for i in c3270 x3270if x3270-script ibm_hosts; do
    install -m644 $i.man $RPM_BUILD_ROOT%{_mandir}/man1/$i.1
done
cd ..

install -m644 X3270.xad ${RPM_BUILD_ROOT}%{_prefix}/X11R6/lib/X11/app-defaults/X3270

( cd $RPM_BUILD_ROOT
  mkdir -p .%{_sysconfdir}/X11/applnk/Utilities
  cat > .%{_sysconfdir}/X11/applnk/Utilities/x3270.desktop <<EOF
[Desktop Entry]
Name=x3270
Type=Application
Comment=3270 terminal emulator
Exec=x3270
EOF
)
%if %{desktop_file}
mkdir -p $RPM_BUILD_ROOT/usr/share/applications
desktop-file-install --vendor net \
        --dir $RPM_BUILD_ROOT/usr/share/applications \
        --add-category "Application;System;X-Red-Hat-Extra" \
        $RPM_BUILD_ROOT%{_sysconfdir}/X11/applnk/Utilities/x3270.desktop

# remove x3270.desktop from the buildroot now that we're done with
# it, as a matter of fact remove all of %{_sysconfdir} since we don't
# have anything there
rm -rf $RPM_BUILD_ROOT%{_sysconfdir}

%endif


rm -f Examples/*.rh
chmod -x Examples/*
for i in pr3287 x3270if; do
	mv $RPM_BUILD_ROOT/usr/X11R6/bin/$i $RPM_BUILD_ROOT/usr/bin
	ln -s ../../bin/$i $RPM_BUILD_ROOT/usr/X11R6/bin
done

%clean
rm -rf $RPM_BUILD_ROOT

%post x11
cd %{_prefix}/X11R6/lib/X11/fonts/misc && %{_prefix}/X11R6/bin/mkfontdir

%postun x11
if [ "$1" = "0" ]; then
  cd %{_prefix}/X11R6/lib/X11/fonts/misc && %{_prefix}/X11R6/bin/mkfontdir
fi

%files
%defattr(-,root,root)
%doc README Examples html LICENSE
%{_prefix}/bin/pr3287
%{_prefix}/bin/x3270if
%{_mandir}/man1/ibm_hosts*
%{_mandir}/man1/x32*
%dir %{_prefix}/lib/x3270
%config(noreplace) %{_prefix}/lib/x3270/ibm_hosts

%files x11
%defattr(-,root,root)
%{_prefix}/X11R6/bin/x3270
%{_prefix}/X11R6/bin/pr3287
%{_prefix}/X11R6/bin/x3270if
%{_prefix}/X11R6/lib/X11/fonts/misc/3270*
%{_prefix}/X11R6/man/man1/*
%if %{desktop_file}
/usr/share/applications/*
%else
%config(missingok) %{_sysconfdir}/X11/applnk/Utilities/*
%endif
%config %{_prefix}/X11R6/lib/X11/app-defaults/X3270

%files text
%defattr(-,root,root)
%{_prefix}/bin/c3270
%{_mandir}/man1/c3270*

%changelog
* Thu Oct 21 2004 Karsten Hopp <karsten@redhat.de> 3.3.2.p1-7
- enable builds on ppc(64) again (#136703)

* Wed Jul 07 2004 Karsten Hopp <karsten@redhat.de> 3.3.2.p1-6
- rebuild with new gcc

* Mon Jul 05 2004 Karsten Hopp <karsten@redhat.de> 3.3.2.p1-5 
- update c3270 package to patchlevel2
- fix buildrequires (#124280)
- fix compiler warnings (#106312, #78479)

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Tue Feb 17 2004 Karsten Hopp <karsten@redhat.de> 3.3.2.p1-3 
- include license file

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Thu Jan 15 2004 Karsten Hopp <karsten@redhat.de> 3.3.2.p1-1
- update to 3.3.2.p1

* Wed Dec 03 2003 Karsten Hopp <karsten@redhat.de> 3.3.2-1
- update to latest stable release, now with SSL and DBCS support

* Tue Aug 12 2003 Karsten Hopp <karsten@redhat.de> 3.2.20-4.2
- check for libncursesw and use it if available

* Wed Jul 09 2003 Karsten Hopp <karsten@redhat.de> 3.2.20-4.1
- rebuilt

* Wed Jul 09 2003 Karsten Hopp <karsten@redhat.de> 3.2.20-4
- fix segfault when ~/.x3270connect isn't writable by the user

* Tue Jun 17 2003 Karsten Hopp <karsten@redhat.de> 3.2.20-3.1
- rebuilt

* Tue Jun 17 2003 Karsten Hopp <karsten@redhat.de> 3.2.20-3
- rebuild 

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Mon May 05 2003 Karsten Hopp <karsten@redhat.de> 3.2.20-1
- update to 3.2.20

* Tue Apr  1 2003 Thomas Woerner <twoerner@redhat.com>
- fixed inclusion of time header file (sys/time.h -> time.h)

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Tue Nov 19 2002 Karsten Hopp <karsten@redhat.de> 3.2.19-3
- update to patchlevel 4:
  Re-enable the automatic font switching when the
  x3270 window is resized

* Tue Nov 19 2002 Tim Powers <timp@redhat.com>
- rebuild for all arches
- remove cruft from the buildroot we aren't shipping

* Wed Jul 24 2002 Karsten Hopp <karsten@redhat.de>
- 3.2.19
- use desktop-file-utils

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Mon Mar  4 2002 Bernhard Rosenkraenzer <bero@redhat.com> 3.2.18-2
- Update to 3.2.18 patchlevel 14

* Wed Jan 16 2002 Bernhard Rosenkraenzer <bero@redhat.com> 3.2.18-1
- 3.2.18
- Don't ship x3270-tcl anymore

* Mon Jul 16 2001 Bernhard Rosenkraenzer <bero@redhat.com> 3.2.16-4
- Add build dependencies (#48930)

* Sat Jun 09 2001 Florian La Roche <Florian.LaRoche@redhat.de>
- remove all provides/requires for x3270-frontend

* Sun May 13 2001 Bernhard Rosenkraenzer <bero@redhat.com> 3.2.16-2
- Rebuild with new readline

* Thu May 10 2001 Bernhard Rosenkraenzer <bero@redhat.com> 3.2.16-1
- 3.2.16
- adapt patches
- get rid of the **** pdksh requirement
- split the tcl version into a different package, no need to require tcl for
  normal use
- split the x11 frontend into a separate package.
  We don't necessarily have X on a machine where we want to run
  3270 sessions (e.g. s390...)

* Fri Dec 22 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 3.2.14
- Add c3270 (textmode x3270) in x3270-text package
- Fix build
- Make ibm_hosts a %config(noreplace)

* Tue Oct 24 2000 Jeff Johnson <jbj@redhat.com>
- remove /usr/local paths in Examples.

* Sun Oct 22 2000 Jeff Johnson <jbj@redhat.com>
- update to 3.2.13.

* Thu Jul 13 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Fri Jun  2 2000 Jeff Johnson <jbj@redhat.com>
- rebuild for 7.0

* Mon Feb 07 2000 Preston Brown <pbrown@redhat.com>
- wmconfig -> desktop

* Mon Feb  7 2000 Jeff Johnson <jbj@redhat.com>
- compress man pages.

* Fri Jan 14 2000 Jeff Johnson <jbj@redhat.com>
- update to 3.1.1.9 (see URL for pending 3.2alpha version).

* Fri Sep 24 1999 Preston Brown <pbrown@redhat.com>
- change to directory before doing a mkfontdir

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 7)

* Tue Jan 12 1999 Jeff Johnson <jbj@redhat.com>
- ibm_hosts needed %config (#788)

* Fri Aug  7 1998 Jeff Johnson <jbj@redhat.com>
- build root

* Fri May 01 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Wed Oct 22 1997 Marc Ewing <marc@redhat.com>
- new version
- added wmconfig entry

* Mon Jul 21 1997 Erik Troan <ewt@redhat.com>
- built against glibc
